<?php 

	include ("authnet-function.php");
	require_once 'paypal-function.php';
	
	include_once ("dap-config.php");
	include("securimage.php");

	$read_post_param_only = 'N';
	
	if ((!isset($_POST['payment_err_page']) || ($_POST['payment_err_page'] == '')) ||
		(!isset($_SESSION['payment_err_page']) || ($_SESSION['payment_err_page'] != ''))) {
		$payment_err_page = SITE_URL_DAP."/dap/paymentError.php";
		$payment_err_page= str_replace ( "http:", "https:", $payment_err_page );
	}
	
	if (isset ($_SESSION['password']) && ($_SESSION['password'] != '')) {
		$user = Dap_User::loadAdminUserByMinId();
		if (!isset($user)) {
			$error_url = $payment_err_page."?response_msg=Admin issue. Please contact the site-admin";
			header("Location: " . $error_url);
			return;
		}
		$password = $user->getPassword();
		if (!isset ($password)) {
			$error_url = $payment_err_page."?response_msg=Admin issue. Please contact the site-admin";
			header("Location: " . $error_url);
			return;
		}
		
		if (!strcasecmp($_SESSION['password'], $password)) {
		//match found
			$read_post_param_only = 'Y';
			unset($_SESSION['password']);
		}
	}
	$paymentObj = new Dap_Payment();
	$paymentObj->setSessionParams($_POST);
	
	if ($paymentObj->validateRequiredFields($_POST) == FALSE) { //failed
		header("Location: ".$payment_url);
	}
	
	$payment_url = SITE_URL_DAP . "/dap/buy.php";
	$payment_url= str_replace ( "http:", "https:", $payment_url );
			
	logToFile("dap-buy-submit: S_SESSION password is " . $_SESSION['password'],LOG_DEBUG_DAP); 
	logToFile("dap-buy-submit: read_post_param_only is " . $read_post_param_only,LOG_DEBUG_DAP); 
	
	if ((isset($_POST['cmcc_acctnum']) && ($_POST['cmcc_acctnum'] != '')) ||
		(isset($_SESSION['cmcc_acctnum']) && ($_SESSION['cmcc_acctnum'] != ''))) {
		$payment_url = SITE_URL_DAP . "/cmcc/buy.php";
	}
	
	$payment_gateway = $_POST['payment_gateway'];
	
	if ($_POST['payment_gateway'] == "paypal") {
		logToFile("dap-buy-submit: Entered payment gateway loop",LOG_DEBUG_DAP);
		
		if ($read_post_param_only == 'Y' && isset($_POST['cardtype'])) {
			$paymentObj->setCard_type($_POST['cardtype']);
		}
		else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getCard_type())
			$paymentObj->setCard_type($_SESSION['paymentObj']->getCard_type());
		else {
			logToFile("dap-buy-submit: missing required field is card_type",LOG_DEBUG_DAP);
			$_SESSION['err_text']="Sorry, missing required field";
			header("Location: ".$payment_url);
			return;
		}
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['card_num'])) 
		$paymentObj->setCard_num($_POST['card_num']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getCard_num())
		$paymentObj->setCard_num($_SESSION['paymentObj']->getCard_num());
	else {
		logToFile("dap-buy-submit: missing required field is card_num",LOG_DEBUG_DAP);
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['exp_date'])) 
		$paymentObj->setExp_date($_POST['exp_date']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getExp_date())
		$paymentObj->setExp_date($_SESSION['paymentObj']->getExp_date());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is exp_date",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['card_code'])) 
		$paymentObj->setCard_code($_POST['card_code']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getCard_code())
		$paymentObj->setCard_code($_SESSION['paymentObj']->getCard_code());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is card_code",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['first_name'])) 
		$paymentObj->setFirst_name($_POST['first_name']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getFirst_name())
		$paymentObj->setFirst_name($_SESSION['paymentObj']->getFirst_name());
else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is first_name",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['last_name'])) 
		$paymentObj->setLast_name($_POST['last_name']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getLast_name())
		$paymentObj->setLast_name($_SESSION['paymentObj']->getLast_name());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is last_name",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['address'])) 
		$paymentObj->setAddress1($_POST['address']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getAddress1())
		$paymentObj->setAddress1($_SESSION['paymentObj']->getAddress1());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		
		logToFile("dap-buy-submit: missing required field is address",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['city'])) 
		$paymentObj->setCity($_POST['city']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getCity())
		$paymentObj->setCity($_SESSION['paymentObj']->getCity());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is city",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
		
	if ($read_post_param_only == 'Y' && isset($_POST['statevar'])) {
		$paymentObj->setState($_POST['statevar']);
		$paymentObj->setStateCode($_POST['statecode']);
		$_SESSION['statevar'] = $_POST['statevar'];
		$_SESSION['statecode'] = $_POST['statecode'];
	//	logToFile("dap-buy-submit: statevar is " . $_SESSION['statevar'],LOG_DEBUG_DAP); 
	}
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getState()) {
		$paymentObj->setState($_SESSION['paymentObj']->getState());
		$paymentObj->setStateCode($_SESSION['paymentObj']->getStateCode());
	}
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is statevar",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['zip'])) 
		$paymentObj->setZip($_POST['zip']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getZip())
		$paymentObj->setZip($_SESSION['paymentObj']->getZip());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is zip",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
		
	if ($read_post_param_only == 'Y' && isset($_POST['countryvar'])) {
		$paymentObj->setCountry($_POST['countryvar']);
		$paymentObj->setCountryCode($_POST['countrycode']);
		$_SESSION['countryvar'] = $_POST['countryvar'];
		$_SESSION['countrycode'] = $_POST['countrycode'];
		
	//	logToFile("dap-buy-submit: statevar is " . $_SESSION['countryvar'],LOG_DEBUG_DAP); 
	}
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getCountry()) {
		$paymentObj->setCountry($_SESSION['paymentObj']->getCountry());
		$paymentObj->setCountryCode($_SESSION['paymentObj']->getCountryCode());
	}
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is countryvar",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['email'])) 
		$paymentObj->setEmail($_POST['email']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getEmail())
		$paymentObj->setEmail($_SESSION['paymentObj']->getEmail());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		logToFile("dap-buy-submit: missing required field is email",LOG_DEBUG_DAP);
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['phone'])) 
		$paymentObj->setPhone($_POST['phone']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getPhone())
		$paymentObj->setPhone($_SESSION['paymentObj']->getPhone());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['fax'])) 
		$paymentObj->setFax($_POST['fax']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getFax())
		$paymentObj->setFax($_SESSION['paymentObj']->getFax());

	
	if ($read_post_param_only == 'Y' && isset($_POST['ship_to_first_name'])) 
		$paymentObj->setShip_to_first_name($_POST['ship_to_first_name']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_first_name())
		$paymentObj->setShip_to_first_name($_SESSION['paymentObj']->getShip_to_first_name());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['ship_to_last_name'])) 
		$paymentObj->setShip_to_last_name($_POST['ship_to_last_name']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_last_name())
		$paymentObj->setShip_to_last_name($_SESSION['paymentObj']->getShip_to_last_name());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['ship_to_address'])) 
		$paymentObj->setShip_to_address1($_POST['ship_to_address']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_address1())
		$paymentObj->setShip_to_address1($_SESSION['paymentObj']->getShip_to_address1());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['ship_to_city'])) 
		$paymentObj->setShip_to_city($_POST['ship_to_city']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_city())
		$paymentObj->setShip_to_city($_SESSION['paymentObj']->getShip_to_city());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['shipstatevar'])) {
		$paymentObj->setShip_to_state($_POST['shipstatevar']);
		$_SESSION['shipstatevar'] = $_POST['shipstatevar'];
		$paymentObj->setShip_to_statecode($_POST['shipstatecode']);
		$_SESSION['shipstatecode'] = $_POST['shipstatecode'];
	}
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_state()) {
		$paymentObj->setShip_to_state($_SESSION['paymentObj']->getShip_to_state());
		$paymentObj->setShip_to_statecode($_SESSION['paymentObj']->getShip_to_statecode());
	}
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['ship_to_zip'])) 
		$paymentObj->setShip_to_zip($_POST['ship_to_zip']);
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_zip())
		$paymentObj->setShip_to_zip($_SESSION['paymentObj']->getShip_to_zip());
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	if ($read_post_param_only == 'Y' && isset($_POST['shipcountryvar'])) {
		$paymentObj->setShip_to_country($_POST['shipcountryvar']);
		$paymentObj->setShip_to_countrycode($_POST['shipcountrycode']);
		$_SESSION['shipcountryvar'] = $_POST['shipcountryvar'];
		$_SESSION['shipcountrycode'] = $_POST['shipcountrycode'];
	}
	else if (isset($_SESSION['paymentObj']) && $_SESSION['paymentObj']->getShip_to_country()) {
		$paymentObj->setShip_to_country($_SESSION['paymentObj']->getShip_to_country());
		$paymentObj->setShip_to_countrycode($_SESSION['paymentObj']->getShip_to_countrycode());
	}
	else {
		$_SESSION['err_text']="Sorry, missing required field";
		header("Location: ".$payment_url);
		return;
	}
	
	$_SESSION['paymentObj']=$paymentObj;

	if ($read_post_param_only == 'Y') {
	
		$img = new Securimage();
		$valid = $img->check($_POST['code']);
	
		if($valid != true) {
			$_SESSION['err_text']="Sorry, the code you entered was invalid. ";
			header("Location: ".$payment_url);
			return;
		}
	}
	
	if(trim($payment_gateway) == "authnet")
	{ 
		logToFile("buy-submit: Creating " . $payment_gateway . " subscription", LOG_DEBUG_DAP);
		$post = array();
		foreach($_POST as $key=>$value)
		{
			$post[$key] = $value;
		}
		$paymentObj->create_authnet_subscription($post);
	}
	else if(trim($payment_gateway) == "paypal")
	{ 
		logToFile("buy-submit: Creating " . $payment_gateway . " subscription", LOG_DEBUG_DAP);
		$post = array();
		foreach($_POST as $key=>$value)
		{
			$post[$key] = $value;
		}
		$paymentObj->create_paypal_subscription($post);
	}
	else {
		logToFile("buy-submit: payment gateway = " . $payment_gateway . " not supported", LOG_DEBUG_DAP);
		$_SESSION['err_text']="Sorry, the payment gateway = " . $payment_gateway . " is not supported";
		header("Location: ".$payment_url);
		return;
	}
	
	return;
?>
