<?php

	$default_product_id = 1; //Change this to any product id from DAP
	
	include_once ("dap-config.php");	
	
	foreach ($_REQUEST as $key => $value) {
		$value = urlencode(stripslashes($value));
		$req .= "&$key=$value";
		logToFile("dap-getresponse.php: " . $key . "=" . $value);
	}
	
	logToFile($req);

	$first_name = isset($_REQUEST['name']) ? addslashes($_REQUEST['name']) : "";
	$email = isset($_REQUEST['email']) ? addslashes($_REQUEST['email']) : "";
	$productId = isset($_REQUEST['product_id']) ? addslashes($_REQUEST['product_id']) : $default_product_id;
	$ipaddress = getIpOfUser();
	$redirect = Dap_Config::get("LOGIN_URL");
	$thirdParty = false;
	$redirURL = "";
	$msg = "SUCCESS! Thank you for signing up. Please check your email for further details.";
	
	if( ($first_name == "") || ($email == "") || ($productId == "") || strpos($email, "\r") || strpos($email, "\n")	) {
		header("Location:error.php?msg=Sorry, all fields are mandatory. Please go 'back' and fill up the missing information.");
		exit;
	} 

	try {
		Dap_UsersProducts::addUserToProduct($email, $first_name, "", $productId, $ispaid='n', "A");
	} catch (PDOException $e) {
		logToFile($e->getMessage(),LOG_FATAL_DAP);
		$msg = $e->getMessage();
	} catch (Exception $e) {
		logToFile($e->getMessage(),LOG_FATAL_DAP);
		$msg = $e->getMessage();
	}		
	
	$redirURL =  $redirect . "?msg=" . $msg;
	header("Location: " . $redirURL);
	exit;
		
?>