<?php

include_once ("dap-config.php");

//you@yourdomain.com,joe,,test123,Example One-time Product,99 hill ave,cityname,NY,12345,USA,,DAP,y
//you@yourdomain-1.com,joe1,smith	,,Example One-time Product,99 hill ave,cityname,NY,12345,USA,,DAP,y
// veenap@gmail.com,veena,prash,test123,Platinum Membership,99 hill ave,cityname,NY,12345,USA,,DAP,y, 2012-03-16, 2013-01-01

	$post = array();
	$handle = fopen("bulk/importusers.csv", "r");
	if( $handle ) {
		while (($data = fgetcsv($handle)) !== FALSE) {
			if (($data[0] == null) || (trim($data[0]) == ''))
				return;
				
			$post['email'] = trim($data[0]); // email
			$post['first_name'] = trim($data[1]); // firtname;
			$post['last_name'] = trim($data[2]); // lastname;
			$post['password'] = trim($data[3]);
			$post['item_name'] = trim($data[4]); // product name
			
			$post['address1'] = trim($data[5]); // address
			$post['city'] = trim($data[6]); // city
			$post['state'] = trim($data[7]); //state
			$post['zip'] = trim($data[8]); //zip
			$post['country'] = trim($data[9]); //country
			$post['phone'] = trim($data[10]); //phone
			$post['company'] = trim($data[11]); //company
			
			$post['ship_to_first_name'] = trim($data[1]);// shipping first name;
			$post['ship_to_last_name'] = trim($data[2]);// shipping first name;
			$post['ship_to_address1'] = trim($data[5]);// shipping last name
			$post['ship_to_city'] = trim($data[6]);  // shipping city
			$post['ship_to_state'] = trim($data[7]);//shipping state
			$post['ship_to_zip']  = trim($data[8]); // shipping zip
			$post['ship_to_country'] = trim($data[9]); // shipping country
					
			$post['txn_id'] =  rand(1, 1000000); 

			$post['ispaid'] = $data[12];
			$post['access_start_date']=trim($data[13]);
			$post['access_end_date']=trim($data[14]);
			
			$post['user_name'] = trim($data[15]); // username;
			
			logToFile("dap-bulkImport :access_start_date " . $post['access_start_date'] . ": access_end_date" . $post['access_end_date']);
			
			if ($post['first_name'] == '') {
				echo "missing firstname";
				return;
			}
			if ($post['email'] == '') {
				echo "missing email";
				return;
			}
							  
			$ret = bulkImport($post);
			if ($ret == 0) {
				echo "Added " . $post['first_name'] . ":" . $post['email'] . " with ispaid status of " . $post['ispaid'] . "<br>";
				logToFile("dap-bulkImport :Added " . $post['first_name'] . ":" . $post['email'] . " with ispaid status of " . $post['ispaid']);
			}
		}
	
		echo "Bulk Import Completed Successfully! ";
	   logToFile("Bulk Import Completed Successfully! ");
		fclose($handle);
	}

	function bulkImport($post) 
	{
		//translate
		
		logToFile("dap-bulkImport: bulkImport", LOG_DEBUG_DAP);
			
		if ($post['item_name'] == "") {
			$dap_error = "missing product name in the bulkImport notification for the user: " . $post['email'];
			logToFile("dap-bulkImport: " . $dap_error, LOG_DEBUG_DAP);
			sendAdminEmail("dap-bulkImport: missing product name in the bulkImport notification", $dap_error);
			return -1;
		}
		
		//$post['txn_id'] = $post['orderID'];
		$post['txn_type'] = "bulkimport";
			
		if ( !isset($post['payer_email']) || $post['payer_email'] == '' )
			$post['payer_email'] = $post['email'];
	
		$post['item_number'] = "1";
		
		if(!isset($post['payment_status'])) { 
			$post['payment_status'] = 'Completed';
		}
		
		//logToFile("dap-bulkImport: bulkImport - calling recordIncoming", LOG_DEBUG_DAP);
		
		//Lets try to get user and see if it exists
		$user = Dap_User::loadUserByEmail($post['email']);
		//TODO: Should we check for id > 0 or something like that ?
		if(isset($user)) {
			echo "User " . $post['email'] . ":" . $post['first_name'] . " exists. Checking if user is already tied to product" .  "<br>";
			logToFile("dap-bulkImport: User " . $post['email'] . ":" . $post['first_name'] . " exists. Checking if user is already tied to product");
			
			$product = Dap_Product::loadProductByName(trim($post['item_name']));
			
			if( !isset($product) || ($product == NULL) ) {
				echo "Added user " . $post['email'] . ":" . $post['first_name'] . "but Product " . $post['item_name'] . " not found in DAP".  "<br>";
				logToFile("dap-bulkImport: Added user " . $post['email'] . ":" . $post['first_name'] . "but Product " . $post['item_name'] . " not found in DAP");
				return -1;
			}
			
			$userProduct = Dap_UsersProducts::load($user->getId(), $product->getId());
			
			if( isset($userProduct) || ($userProduct != NULL) ) {
				echo "User " . $post['email'] . ":" . $post['first_name'] . " already exists. user already tied to product" .  "<br>";
				logToFile("dap-bulkImport: User " . $post['email'] . ":" . $post['first_name'] . " already exists. user already tied to product");
				return -1;
			}
		
			if (($post['ispaid'] != '') && (($post['ispaid'] == 'Y') || ($post['ispaid'] == 'y')))
				$ispaid =  "y";
			else 
				$ispaid = "n";
		
			$uid = Dap_UsersProducts::addUserToProduct($post['email'], $post['first_name'], $post['last_name'], $product->getId(), $ispaid, "A", "", $post['access_start_date'], $post['access_end_date']);
			
			return 0;
		}
		
	
		$user = new Dap_User();
	//	logToFile("dap-bulkImport :CheckingUser: New User, FirstName:".$post['first_name'].":".$post['cname']);
	
		//store shipping info in user profile 
		if(array_key_exists('ship_to_first_name',$post)) {
			$user->setFirst_name( $post["ship_to_first_name"] );
			$user->setLast_name( $post["ship_to_last_name"] );
		}
		if(array_key_exists('first_name',$post)) {
			$user->setFirst_name( $post["first_name"] );
			$user->setLast_name( $post["last_name"] );
		} else if(array_key_exists('cname',$post)) {
			$user->setFirst_name( $post["cname"] );
			$user->setLast_name( $post["cname"] );
		}
		
		if(array_key_exists('user_name',$post)) {
			$user->setUser_name( $post["user_name"] );
		} 
		
		if(array_key_exists('ship_to_address1',$post)) {
			$user->setAddress1( $post["ship_to_address1"] );
		} else if (array_key_exists('address1',$post)) {
			$user->setAddress1( $post["address1"] );
		}
		
		if(array_key_exists('ship_to_address2',$post)) {
			$user->setAddress2( $post["ship_to_address2"] );
		} else if (array_key_exists('address2',$post)) {
			$user->setAddress2( $post["address2"] );
		}
		
		if(array_key_exists('ship_to_city',$post)) {
			$user->setCity( $post["ship_to_city"] );
		} else if(array_key_exists('city',$post)) {
			$user->setCity( $post["city"] );
		} 
		
		if(array_key_exists('ship_to_state',$post)) {
			$user->setState( $post["ship_to_state"] );
		} else if(array_key_exists('ship_to_state',$post)) {
			$user->setState( $post["ship_to_state"] );
		}
		
		if(array_key_exists('ship_to_zip',$post)) {
			$user->setZip( $post["ship_to_zip"] );
		} else if(array_key_exists('zip',$post)) {
			$user->setZip( $post["zip"] );
		} 
		
		if(array_key_exists('ship_to_country',$post)) {
			$user->setCountry( $post["ship_to_country"] );
		} else if(array_key_exists('country',$post)) {
			$user->setCountry( $post["country"] );
		}
		
		if(array_key_exists('phone',$post)) {
			$user->setPhone( $post["phone"] );
		} 
		if(array_key_exists('fax',$post)) {
			$user->setFax( $post["fax"] );
		} 
		if(array_key_exists('company',$post)) {
			$user->setCompany( $post["company"] );
		} 
				
		$user->setEmail( $post["email"]);		
		$user->setStatus("A");
		
		if ($post['password'] != '')
		 $user->setPassword($post['password']);
		 
		$user->create();
		
		if (($post['ispaid'] != '') && (($post['ispaid'] == 'Y') || ($post['ispaid'] == 'y')))
			$ispaid =  "y";
		else 
			$ispaid = "n";
		
		logToFile("dap-bulkImport :Imported " . $post['email'].":".$post['first_name']);
		
		$product = Dap_Product::loadProductByName(trim($post['item_name']));
		if( !isset($product) || ($product == NULL) ) {
			echo "Added user " . $post['email'] . ":" . $post['first_name'] . "but Product " . $post['item_name'] . " not found in DAP".  "<br>";
			logToFile("dap-bulkImport: Added user " . $post['email'] . ":" . $post['first_name'] . "but Product " . $post['item_name'] . " not found in DAP");
			
			return -1;
		}
		
		$uid = Dap_UsersProducts::addUserToProduct($post['email'], $post['first_name'], $post['last_name'], $product->getId(), $ispaid, "A", "", $post['access_start_date'], $post['access_end_date']);
	
	//logToFile("dap-bulkImport :added user to product " . $uid.":".$post['item_name']);
	return 0;
}

?>