<?php

class Dap_API extends Dap_Base {

	
	/**
		This function returns true or false
		Checks if currently logged in user has access to given products
	*/
	public static function hasAccessTo($productId) {
		$hasAccess = false;
		if( Dap_Session::isLoggedIn() ) { 
			//get userid
			$session = Dap_Session::getSession();
			$user = $session->getUser();
			$hasAccess = $user->hasAccessTo($productId);
		}
		return $hasAccess;
	}
	
	
	public static function hasAccessToProducts($productIds) {
		$hasAccess = false;
		if( Dap_Session::isLoggedIn() ) { 
			//get userid
			$session = Dap_Session::getSession();
			$user = $session->getUser();
			$hasAccess = $user->hasAccessToProducts($productIds);
		}
		return $hasAccess;
	}	
	
	
	
}
?>